frr defaults datacenter
hostname {{ inventory_hostname }}
username cumulus nopassword
!
service integrated-vtysh-config
!
log syslog informational
!
ip pim rp {{ multicast.underlay[devices[inventory_hostname].site].rpaddr|ipaddr('address') }} 224.0.0.0/4
ip msdp mesh-group cumulus source {{ devices[inventory_hostname].interfaces.loopback.ipv4|ipaddr('address') }}
ip pim ecmp
ip pim keep-alive-timer 3600
{% for mesh in multicast.underlay.rpmesh %}
{% if mesh != inventory_hostname %}
ip msdp mesh-group cumulus member {{ devices[mesh].interfaces.loopback.ipv4|ipaddr('address') }}
{% endif %}
{% endfor %}
!
{% set l3 = tenants.l3domain %}
{% for domain in l3 %}
{% if domain in devices[inventory_hostname].vrfs %}
vrf {{ domain }}
 vni {{ 400000 + l3[domain].id }}
{% endif %}
{% endfor %}
!
interface ipmr-lo
 ip pim
!
interface lo
 ip igmp
 ip pim
 ip pim use-source {{ devices[inventory_hostname].interfaces.loopback.ipv4|ipaddr('address') }}
!
{% for interface in devices[inventory_hostname].interfaces.fabric %}
interface {{ interface }}
 ip pim sm
{% endfor %}
!
router bgp {{ devices[inventory_hostname].routing.bgp.asn }}
 bgp router-id {{ devices[inventory_hostname].interfaces.loopback.ipv4|ipaddr('address') }}
 bgp bestpath as-path multipath-relax
 neighbor underlay peer-group
 neighbor underlay remote-as external
{% for interface in devices[inventory_hostname].interfaces.fabric %}
 neighbor {{ interface }} interface peer-group underlay
{% endfor %}
{% if devices[inventory_hostname].interfaces.mlag is defined %}
 neighbor peerlink.4094 interface peer-group underlay
{% endif %}
 !
 address-family ipv4 unicast
  redistribute connected route-map loopbacks 
 exit-address-family
 !
 address-family ipv6 unicast
 exit-address-family
 !
 address-family l2vpn evpn
  neighbor underlay activate
  advertise-all-vni
  advertise-svi-ip
 exit-address-family
!
!
{% for vrf in devices[inventory_hostname].vrfs %}
router bgp {{ devices[inventory_hostname].routing.bgp.asn }} vrf {{ vrf }}
 bgp router-id {{ devices[inventory_hostname].interfaces.loopback.ipv4|ipaddr('address') }}
 neighbor roh peer-group
 neighbor roh remote-as external
 neighbor external peer-group
 neighbor external remote-as external
{% if devices[inventory_hostname].routing.bgp.vrf[vrf].neighbor is defined %}
{% for peer in devices[inventory_hostname].routing.bgp.vrf[vrf].neighbor %}
 {% set neighbor = devices[inventory_hostname].routing.bgp.vrf[vrf].neighbor[peer] %}
 neighbor {{ peer }} peer-group external
{% endfor %}
{% endif %}
{% if devices[inventory_hostname].routing.bgp.vrf[vrf].roh is defined %}
{% for interface in devices[inventory_hostname].routing.bgp.vrf[vrf].roh %}
 neighbor {{ interface }} interface peer-group roh
{% endfor %}
{% endif %}
 !
 address-family ipv4 unicast
  redistribute connected route-map routing-{{ vrf }}
{% set l2 = tenants.l2domain %}
{% if l3[vrf].leak is defined %}
  import vrf route-map vrf-loop
{% for leak in l3[vrf].leak %}
  import vrf {{ leak }}
{% endfor %}
{% endif %}
 exit-address-family
 !
 address-family ipv6 unicast
  redistribute connected
 exit-address-family
 !
 address-family l2vpn evpn
  advertise ipv4 unicast
  advertise ipv6 unicast
 exit-address-family
!
{% endfor %}
!
bgp community-list 10 permit 0:10
!
{% for vrf in devices[inventory_hostname].vrfs %}
route-map routing-{{ vrf }} permit 10
 match interface {{ vrf }}
{% for interface in devices[inventory_hostname].interfaces.routed %}
{% if vrf == devices[inventory_hostname].interfaces.routed[interface].vrf %}
{% if not devices[inventory_hostname].interfaces.routed[interface].unnumbered %}
route-map routing-{{ vrf }} permit 10{{ loop.index }}
 match interface {{ interface }}
{% endif %}
{% endif %}
{% endfor %}
!
{% endfor %}
!
route-map loopbacks permit 10
 match interface lo
!
route-map vrf-loop deny 10
 match community 10
!
route-map vrf-loop permit 20
 set community 0:10
!
line vty
!
